import time
import allure
import pytest_check
import pytest_check as check
import pytest

from bo_shared.bo_service_pages import BoService
from selenium.webdriver.common.by import By
from role_service.pages.policy_management import RolePolicyManagement

from utils.envs import Envs
from utils.decorators import execute_env


@allure.feature('Role Service Policy test')
class TestRolePolicy():

    # - **Use case  Main page**
    #     - [ ]  **Use case1 - Login**
    #     - [ ]  **Use case2 - logout**
    # - **Use case Policy page**
    #     - [ ]  **Use case3 - Create New Policy**
    @execute_env(envs=(Envs.DEV.value, ))
    @allure.epic("case3 - Create New Policy")
    @allure.severity(allure.severity_level.BLOCKER)
    @allure.link('https://hermes.devgambit.net/browse/PSS-354', name='[Role][Policy Page] Use Case 3 - Create New Policy')
    @allure.story("Create New Policy")
    def test_for_create_a_new_policy(self, driver, test_account, test_role_data):
        policy = RolePolicyManagement(driver)
        policy.login(test_account)
        policy.add_new_policy()
        breadcrumb = policy.get_current_breadcrumb_lv3()
        check.is_in("Add New Policy", breadcrumb)
        time.sleep(1)
        random_policy_item = policy.create_random_policy('case3')
        time.sleep(1)
        policy.select_policy_permission()
        time.sleep(1)
        policy.create_policy()
        time.sleep(1)
        policy.confirm_create_policy()
        time.sleep(1)
        policy.search_policy_by_random_name_file('case3')
        time.sleep(1)
        policy.click_search_btn()
        first_policy_name = policy.get_1st_policy_name()
        check.equal(first_policy_name, random_policy_item)
        time.sleep(1)
        first_policy_status = policy.get_1st_policy_status_list()
        check.equal(first_policy_status, test_role_data['status_eq_activate'])
        policy.click_the_1st_policy_detail()
        time.sleep(1)
        policy_detail_name = policy.get_the_policy_name_in_detail_page()
        check.equal(policy_detail_name, random_policy_item)
        time.sleep(1)
        policy.delete_first_policy()
        time.sleep(1)

    #     - [ ]  **Use case4 - SET-UP the Policy’s Permission**
    @allure.epic("case4 - SET-UP the Policy’s Permission")
    @allure.severity(allure.severity_level.BLOCKER)
    @allure.link('https://hermes.devgambit.net/browse/PSS-355', name="[Role][Policy Page] Use Case 4 - Set up Policy's Permissions")
    @allure.story("SET-UP the Policy’s Permission")
    def test_for_setup_policy_permission(self, driver, test_account, test_role_data):
        policy = RolePolicyManagement(driver)
        policy.login(test_account)
        policy.create_new_policy('case4')
        policy.search_policy_by_random_name_file('case4')
        policy.click_search_btn()
        policy.click_the_1st_policy_detail()
        time.sleep(3)
        policy.edit_policy()
        time.sleep(1)
        policy.confirm_edit_policy()
        time.sleep(1)
        policy.modify_policy_name(test_role_data['modify_policy_name'])
        policy.unselect_policy_permission()
        policy.reselect_policy_permission()
        policy.save_policy()
        time.sleep(2)
        policy.search_policy_by_modify_name(test_role_data['modify_policy_name'])
        time.sleep(1)
        policy.click_search_btn()
        time.sleep(1)
        first_policy_name = policy.get_1st_policy_name()
        time.sleep(1)
        check.equal(first_policy_name, test_role_data['modify_policy_name'])
        time.sleep(1)
        first_policy_status = policy.get_1st_policy_status_list()
        check.equal(first_policy_status, test_role_data['status_eq_activate'])
        policy.click_the_1st_policy_detail()
        time.sleep(1)
        policy_detail_name = policy.get_the_policy_name_in_detail_page()
        time.sleep(1)
        check.equal(policy_detail_name, test_role_data['modify_policy_name'])
        policy.delete_first_policy()

    #     - [ ]  **Use case5 - Duplicate Policy**
    @execute_env(envs=(Envs.DEV.value, ))
    @allure.epic("case5 - Duplicate Policy")
    @allure.severity(allure.severity_level.BLOCKER)
    @allure.link('https://hermes.devgambit.net/browse/PSS-356', name="[Role][Policy Page] Use Case 5 - Duplicate Policy")
    @allure.story("Duplicate Policy")
    def test_for_duplicate_policy(self, driver, test_account, test_role_data):
        policy = RolePolicyManagement(driver)
        policy.login(test_account)
        policy.create_new_policy('case5')
        policy.search_policy_by_random_name_file('case5')
        policy.click_search_btn()
        policy.click_the_1st_policy_detail()
        policy.click_the_action_btn_in_detail()
        policy.select_duplicate()
        policy.input_duplicate_item_name(test_role_data['duplicate_policy_name'])
        policy.unselect_policy_permission()
        time.sleep(3)
        policy.reselect_policy_permission()
        time.sleep(1)
        policy.create_policy()
        time.sleep(1)
        policy.confirm_create_policy()
        time.sleep(1)
        policy.search_policy_by_duplicate_name(test_role_data['duplicate_policy_name'])
        time.sleep(1)
        policy.click_search_btn()
        time.sleep(1)
        first_policy_name = policy.get_1st_policy_name()
        check.equal(first_policy_name, test_role_data['duplicate_policy_name'])
        time.sleep(1)
        first_policy_status = policy.get_1st_policy_status_list()
        check.equal(first_policy_status, test_role_data['status_eq_activate'])
        policy.click_the_1st_policy_detail()
        time.sleep(1)
        policy_detail_name = policy.get_the_policy_name_in_detail_page()
        check.equal(policy_detail_name, test_role_data['duplicate_policy_name'])
        policy.delete_first_policy()
        policy.search_policy_by_random_name_file('case5')
        random_policy_name = policy.get_random_policy_name_by_file('case5')
        first_policy_name = policy.get_1st_policy_name()
        check.equal(first_policy_name, random_policy_name)
        policy.click_the_1st_policy_detail()
        policy.delete_first_policy()

    #     - [ ]  **Use case6 - Deactivate Policy**
    #     - [ ]  **Use case6 - Activate/ Deactivate Policy**
    @execute_env(envs=(Envs.DEV.value, ))
    @allure.epic("case6 - Activate/ Deactivate Policy")
    @allure.severity(allure.severity_level.BLOCKER)
    @allure.link('https://hermes.devgambit.net/browse/PSS-357', name="[Role][Policy Page] Use Case 6 - Activate/Deactivate Policy")
    @allure.story("Deactivate Policy")
    def test_for_deactivate_policy(self, driver, test_account, test_role_data):
        policy = RolePolicyManagement(driver)
        policy.login(test_account)
        policy.create_new_policy('case6')
        policy.search_policy_by_random_name_file('case6')
        time.sleep(2)
        policy.click_search_btn()
        policy.click_the_1st_policy_detail()
        policy.click_the_action_btn_in_detail()
        policy.select_deactivate()
        time.sleep(1)
        policy.select_cancel_for_popup()
        time.sleep(1)
        policy.click_the_action_btn_in_detail()
        policy.select_deactivate()
        time.sleep(1)
        policy.select_confirm_deactivate()
        time.sleep(1)
        detail_policy_status = policy.get_1st_status_in_detail_page()
        check.equal(detail_policy_status, test_role_data['status_eq_deactivate'])
        time.sleep(2)
        policy.click_service_func_list(
            BoService.Role.ServiceName,
            BoService.Role.PolicyManagement
        )
        time.sleep(1)
        first_policy_status = policy.get_1st_policy_status_list()
        check.equal(first_policy_status, test_role_data['status_eq_deactivate'])
        policy.search_policy_by_random_name_file('case6')
        time.sleep(2)
        policy.click_search_btn()
        policy.click_the_1st_policy_detail()
        policy.delete_first_policy()

    #     - [ ]  **Use case7 - Activate Policy**
    @execute_env(envs=(Envs.DEV.value, ))
    @allure.epic("case7 - Activate/ Deactivate Policy")
    @allure.severity(allure.severity_level.BLOCKER)
    @allure.link('https://hermes.devgambit.net/browse/PSS-357', name="[Role][Policy Page] Use Case 6 - Activate/Deactivate Policy")
    @allure.story("Activate Policy")
    def test_for_activate_policy(self, driver, test_account, test_role_data):
        policy = RolePolicyManagement(driver)
        policy.login(test_account)
        policy.create_new_policy('case7')
        policy.search_policy_by_random_name_file('case7')
        policy.click_search_btn()
        time.sleep(1)
        policy.click_the_1st_policy_detail()
        time.sleep(1)
        policy.click_the_action_btn_in_detail()
        policy.select_deactivate()
        time.sleep(1)
        policy.select_confirm_deactivate()
        time.sleep(3)
        policy.click_the_action_btn_in_detail()
        time.sleep(2)
        policy.select_activate()
        time.sleep(2)
        detail_policy_status = policy.get_1st_status_in_detail_page()
        check.equal(detail_policy_status, test_role_data['status_eq_activate'])
        time.sleep(2)
        policy.click_service_func_list(
            BoService.Role.ServiceName,
            BoService.Role.PolicyManagement
        )
        time.sleep(1)
        first_policy_status = policy.get_1st_policy_status_list()
        check.equal(first_policy_status, test_role_data['status_eq_activate'])
        policy.click_the_1st_policy_detail()
        policy.delete_first_policy()

    # - [ ]  **Use case7 - Delete Policy**
    # - [ ]  **Use case8 - Delete Policy**
    @execute_env(envs=(Envs.DEV.value, ))
    @allure.epic("case8 - Delete Policy")
    @allure.severity(allure.severity_level.BLOCKER)
    @allure.link('https://hermes.devgambit.net/browse/PSS-358', name="[Role][Policy Page] Use Case 7 - Delete Policy")
    @allure.story("Delete Policy")
    def test_for_delete_policy(self, driver, test_account, test_role_data):
        policy = RolePolicyManagement(driver)
        policy.login(test_account)
        policy.create_new_policy('case8')
        policy.search_policy_by_random_name_file('case8')
        policy.click_search_btn()
        time.sleep(2)
        policy.click_the_1st_policy_detail()
        time.sleep(2)
        policy.click_the_action_btn_in_detail()
        time.sleep(2)
        policy.select_delete()
        time.sleep(2)
        policy.select_cancel_for_popup()
        time.sleep(2)
        policy.click_the_action_btn_in_detail()
        time.sleep(2)
        policy.select_delete()
        time.sleep(2)
        policy.select_confirm_delete()
        time.sleep(2)
        policy.click_service_func_list(
            BoService.Role.ServiceName,
            BoService.Role.PolicyManagement
        )
        time.sleep(1)
        table_content = policy.get_policy_table_content()
        random_policy_name = policy.get_random_policy_name_by_file('case8')
        check.is_not_in(random_policy_name, table_content)
